# ExtensionChain

- [JSON representation](https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#SCHEMA_REPRESENTATION)
- [MatchCondition](https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#MatchCondition)
  - [JSON representation](https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#MatchCondition.SCHEMA_REPRESENTATION)
- [Extension](https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#Extension)
  - [JSON representation](https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#Extension.SCHEMA_REPRESENTATION)
- [EventType](https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#EventType)

A single extension chain wrapper that contains the match conditions and extensions to execute.

| JSON representation |
|---|
| ``` { "name": string, "matchCondition": { object (`https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#MatchCondition`) }, "extensions": [ { object (`https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#Extension`) } ] } ``` |

| Fields ||
|---|---|
| `name` | `string` Required. The name for this extension chain. The name is logged as part of the HTTP request logs. The name must conform with RFC-1034, is restricted to lower-cased letters, numbers and hyphens, and can have a maximum length of 63 characters. Additionally, the first character must be a letter and the last a letter or a number. |
| `matchCondition` | ``object (`https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#MatchCondition`)`` Required. Conditions under which this chain is invoked for a request. |
| `extensions[]` | ``object (`https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#Extension`)`` Required. A set of extensions to execute for the matching request. At least one extension is required. Up to 3 extensions can be defined for each extension chain for `LbTrafficExtension` resource. `LbRouteExtension` chains are limited to 1 extension per extension chain. |

## MatchCondition

Conditions under which this chain is invoked for a request.

| JSON representation |
|---|
| ``` { "celExpression": string } ``` |

| Fields ||
|---|---|
| `celExpression` | `string` Required. A Common Expression Language (CEL) expression that is used to match requests for which the extension chain is executed. For more information, see [CEL matcher language reference](https://cloud.google.com/service-extensions/docs/cel-matcher-language-reference). |

## Extension

A single extension in the chain to execute for the matching request.

| JSON representation |
|---|
| ``` { "name": string, "authority": string, "service": string, "supportedEvents": [ enum (`https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#EventType`) ], "timeout": string, "failOpen": boolean, "forwardHeaders": [ string ] } ``` |

| Fields ||
|---|---|
| `name` | `string` Required. The name for this extension. The name is logged as part of the HTTP request logs. The name must conform with RFC-1034, is restricted to lower-cased letters, numbers and hyphens, and can have a maximum length of 63 characters. Additionally, the first character must be a letter and the last a letter or a number. |
| `authority` | `string` Optional. The `:authority` header in the gRPC request sent from Envoy to the extension service. Required for Callout extensions. |
| `service` | `string` Required. The reference to the service that runs the extension. Currently only callout extensions are supported here. To configure a callout extension, `service` must be a fully-qualified reference to a [backend service](https://cloud.google.com/compute/docs/reference/rest/v1/backendServices) in the format: `https://www.googleapis.com/compute/v1/projects/{project}/regions/{region}/backendServices/{backendService}` or `https://www.googleapis.com/compute/v1/projects/{project}/global/backendServices/{backendService}`. |
| `supportedEvents[]` | ``enum (`https://docs.cloud.google.com/service-mesh/v1.22/docs/reference/network-services/rest/v1/ExtensionChain#EventType`)`` Optional. A set of events during request or response processing for which this extension is called. This field is required for the `LbTrafficExtension` resource. It must not be set for the `LbRouteExtension` resource. |
| `timeout` | ``string (`https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#google.protobuf.Duration` format)`` Optional. Specifies the timeout for each individual message on the stream. The timeout must be between 10-1000 milliseconds. Required for Callout extensions. A duration in seconds with up to nine fractional digits, ending with '`s`'. Example: `"3.5s"`. |
| `failOpen` | `boolean` Optional. Determines how the proxy behaves if the call to the extension fails or times out. When set to `TRUE`, request or response processing continues without error. Any subsequent extensions in the extension chain are also executed. When set to `FALSE` or the default setting of `FALSE` is used, one of the following happens: - If response headers have not been delivered to the downstream client, a generic 500 error is returned to the client. The error response can be tailored by configuring a custom error response in the load balancer. - If response headers have been delivered, then the HTTP stream to the downstream client is reset. |
| `forwardHeaders[]` | `string` Optional. List of the HTTP headers to forward to the extension (from the client or backend). If omitted, all headers are sent. Each element is a string indicating the header name. |

## EventType

The part of the request or response for which the extension is called.

| Enums ||
|---|---|
| `EVENT_TYPE_UNSPECIFIED` | Unspecified value. Do not use. |
| `REQUEST_HEADERS` | If included in `supportedEvents`, the extension is called when the HTTP request headers arrive. |
| `REQUEST_BODY` | If included in `supportedEvents`, the extension is called when the HTTP request body arrives. |
| `RESPONSE_HEADERS` | If included in `supportedEvents`, the extension is called when the HTTP response headers arrive. |
| `RESPONSE_BODY` | If included in `supportedEvents`, the extension is called when the HTTP response body arrives. |
| `REQUEST_TRAILERS` | If included in `supportedEvents`, the extension is called when the HTTP request trailers arrives. |
| `RESPONSE_TRAILERS` | If included in `supportedEvents`, the extension is called when the HTTP response trailers arrives. |